"""Raw representations of every data type in the AWS WorkSpaces service.

See Also:
    `AWS developer guide for WorkSpaces
    <https://docs.aws.amazon.com/workspaces/latest/adminguide/index.html>`_

This file is automatically generated, and should not be directly edited.
"""

from attr import attrib
from attr import attrs

from ..core import ATTRSCONFIG
from ..core import Resource
from ..core import ResourceProperties
from ..core import create_object_converter

__all__ = ["Workspace", "WorkspaceProperties"]


@attrs(**ATTRSCONFIG)
class WorkspaceProperties(ResourceProperties):
    BundleId = attrib(default=None)
    DirectoryId = attrib(default=None)
    RootVolumeEncryptionEnabled = attrib(default=None)
    Tags = attrib(default=None)
    UserName = attrib(default=None)
    UserVolumeEncryptionEnabled = attrib(default=None)
    VolumeEncryptionKey = attrib(default=None)
    WorkspaceProperties = attrib(default=None)


@attrs(**ATTRSCONFIG)
class Workspace(Resource):
    """A Workspace for WorkSpaces.

    See Also:
        `AWS Cloud Formation documentation for Workspace
        <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-workspaces-workspace.html>`_
    """

    RESOURCE_TYPE = "AWS::WorkSpaces::Workspace"

    Properties: WorkspaceProperties = attrib(
        factory=WorkspaceProperties,
        converter=create_object_converter(WorkspaceProperties),
    )
